      
   10 REM UOSAT Telemetry display
   20 REM BBC file U2TM9
   30 REM Written by C.Wallis G3CWV
   40 REM Created 12-Feb-88
   41 REM Interpreters BBC BASIC v3.06 (Jon Welch) for DOS
   42 REM              BBCBASIC for Windows V2.04
   45 REM V 1.3  13-Sep-95
   50 REM Mods include BCR efficiency, total mag field, S-beacon
   55 REM V 1.4 18-Apr-97 Minor mods to work with BBCBASIC.EXE on PC
   56 REM V 1.5 03-May-03 Mod at 1695 to prevent scan incrementing by 3
   57 REM V 1.6 26-February-2004 '*" added to line 420
      REM  echo response at 270-360 &  multiple exit points added to PROCanalogue_tm
      REM Mag cals, wing cals, SB pwr cal, array decimals
   60 REM DO NOT RENUMBER ... prog refers to line numbers 5000 and 6000
   80 REPEAT
   90   PRINT
  100   PRINT "Enter TELEMETRY DATA file name "
  110   INPUT"or press return for default file TEMP.DAT  "reply$
  120   IF reply$ ="" THEN file_name$="TEMP.DAT" ELSE file_name$=reply$
  130   f1 = OPENIN(file_name$)
  140   IF f1<1 THEN PRINT:PRINT"File not found!"
  150 UNTIL f1>0
  160 REM File now open
  170 file_length%= EXT# f1 :REM Get file size file_length%
  180 file_ptr%=0 : REM Set file pointer to start of file
  190 DIM c%(6)  :REM Array of characters
  195 ON ERROR GOSUB 3160
  200 REPEAT: REM **** Main program loop****
  210   PROCget_uosat2
  220   file_ptr%=PTR# f1 :REM Store pointer to start of TM frame
  230   PRINT"Telemetry block found"
  240   PRINT "File pointer =  ";file_ptr%
  250   PROCdisplay_time
  260   PRINT:PRINT:PRINT
  270   PRINT "Display analogue TM? <Y/N> ";
  280   reply$ = GET$ :PRINT reply$
  290   IF FNyes THEN PROCanalogue_tm
  300   PRINT:PRINT
  310   PRINT "Display Status TM? <Y/N> ";
  320   reply$ = GET$ :PRINT reply$
  330   IF FNyes THEN PROCstatus_tm
  340   PRINT:PRINT
  350   PRINT "Another frame? <Y/N> ";
  360   PRINT "  or R to reset file pointer  ";
  370   reply$ = GET$ :PRINT reply$
  380   IF ((reply$="R")OR(reply$="r")) THEN PROCreset_file  :REM Note reset_file doesnt change reply$
  390 UNTIL FNno
  400 REM **** End of MAIN LOOP ****
  410 CLOSE# 0
  420 *BYE      :REM Return to MS-DOS
  430 REM ---------
  440 DEF PROCanalogue_tm
  450 REM Uses get_tm to get n% for selected channel from file, and displays after conversion to real units
  460 REM May modified to include more or less channels, in any order
  470 analogue% = TRUE :REM Data must be in Binary Coded Decimal
  480 p% = 15 :REM Position of results
  490 PRINT
  500 @% = &20106 :REM One decimal figure
  510 PRINT"EXTERNAL TEMPERATURES 'C"
  520 PRINT
  530 PROCget_tm(17)
  540 PRINT"+X";TAB(p%),FNtemp(n%)
  550 PROCget_tm(27)
  560 PRINT"-X";TAB(p%),FNtemp(n%)
  570 PROCget_tm(18)
  580 PRINT"+Y";TAB(p%),FNtemp(n%)
  590 PROCget_tm(28)
  600 PRINT"-Y";TAB(p%),FNtemp(n%)
  610 PROCget_tm(19)
  620 PRINT"+Z";TAB(p%),FNtemp(n%)
  630 PROCget_tm(29)
  640 PRINT"-Z";TAB(p%),FNtemp(n%)
  650 PROCget_tm(11)
  660 PRINT"Nav mag (wing)";TAB(p%),95.7-0.29*n%
  670 PRINT:PRINT "More Channels? Y/N ";
  671 reply$ = GET$:PRINT
  672 IF FNno THEN @%=10:ENDPROC
  680 PRINT:PRINT"EQUIPMENT TEMPERATURES 'C" :PRINT
  690 PROCget_tm(57)
  700 PRINT:PRINT"Battery";TAB(p%),FNtemp(n%)
  710 PROCget_tm(39)
  720 PRINT"Telemetry";TAB(p%),FNtemp(n%)
  730 PROCget_tm(37)
  740 PRINT"145 MHz Beacon";TAB(p%),FNtemp(n%)
  750 PROCget_tm(47)
  760 PRINT"435 MHz Beacon";TAB(p%),FNtemp(n%)
  770 PROCget_tm(58)
  780 PRINT"2.4 GHz Beacon";TAB(p%),FNtemp(n%)
  790 PROCget_tm(48)
  800 PRINT"P/W (-Y)";TAB(p%),FNtemp(n%)
  810 PROCget_tm(49)
  820 PRINT"BCR (-Y)";TAB(p%),FNtemp(n%)
  830 PROCget_tm(59)
  840 PRINT"CCD Imager";TAB(p%),FNtemp(n%)
  850 PROCget_tm(38)
  860 PRINT"Cmd deoder";TAB(p%),FNtemp(n%)
  860 PRINT:PRINT "More Channels? Y/N ";
  862 reply$ = GET$:PRINT
  863 IF FNno THEN @%=10:ENDPROC
  880 PRINT:PRINT"SOLAR ARRAY CURRENTS"
  890 PRINT
  891 @%=&20006 :REM No decimals
  892 array_sum = 0
  900 PROCget_tm(30)
  901 array_sum=array_sum+FNarraycur(n%)
  910 PRINT"+X";TAB(p%),FNarraycur(n%)
  920 PROCget_tm(20)
  921 array_sum=array_sum+FNarraycur(n%)
  930 PRINT"-X";TAB(p%),FNarraycur(n%)
  940 PROCget_tm(10)
  941 array_sum=array_sum+FNarraycur(n%)
  950 PRINT"+Y";TAB(p%),FNarraycur(n%)
  960 PROCget_tm(0)
  961 array_sum=array_sum+FNarraycur(n%)
  970 PRINT"-Y";TAB(p%),FNarraycur(n%)
  971 PRINT"Total";TAB(p%),array_sum
  980 PROCget_tm(40)
  981 array_volts=n%*0.1-51.5
  982 @%=&20106 :REM Back to 1 decimal
  990 PRINT"Array Voltage";TAB(p%),array_volts
 1001 PRINT:PRINT "More Channels? Y/N ";
 1002 reply$ = GET$:PRINT
 1003 IF FNno THEN @%=10:ENDPROC
      
 1010 PRINT
 1020 PRINT"POWER SUPPLIES"
 1030 PRINT
 1040 p% = 20 :REM Longer titles
 1050 PROCget_tm(52)
 1051 batt_volts=n%*.021
 1060 PRINT"Battery voltage";TAB(p%),batt_volts
 1070 @% = &20306 :REM More decimals
 1080 PROCget_tm(53)
 1090 IF n% < 450 THEN PRINT"Cell voltage ";TAB(p%),n%*.0053 :REM Not a cell if its more than 450
 1100 @% = &20106 :REM Back to one decimal
 1110 PROCget_tm(50)
 1111 chg_curr=8.8*(n%-513)
 1120 PRINT"Charge current";TAB(p%),chg_curr
 1130 PROCget_tm(51)
 1131 line_curr=n%*5
 1140 PRINT"+14V line current";TAB(p%),line_curr
 1150 PROCget_tm(21)
 1160 PRINT"+10V line current";TAB(p%),n%*0.97
 1161 PROCget_tm(41)
 1162 PRINT"+5V line current";TAB(p%),n%*0.97
 1170 PROCget_tm(31)
 1180 PRINT"-10V line current";TAB(p%),n%*0.48
 1190 PROCget_tm(54)
 1200 PRINT"Telmetry current";TAB(p%),n%*0.02
 1201 PROCget_tm(44)
 1202 PRINT"Command RX current";TAB(p%),n%*0.92
 1203 bcr_eff=(line_curr+chg_curr)*batt_volts/(array_sum*array_volts)*100
 1204 PRINT"BCR Efficency";TAB(p%),bcr_eff
 1210 PRINT:PRINT "More Channels? Y/N ";
 1211 y$ = GET$:PRINT
 1213 IF FNno THEN @%=10:ENDPROC
      
 1220 p% = 15 : REM shorter titles again
 1230 PRINT:PRINT"145 MHz BEACON"
 1240 PROCget_tm(36)
 1250 PRINT"Current";TAB(p%),0.22*n%
 1260 PROCget_tm(35)
 1270 PRINT"Power";TAB(p%),2.5*n%-275;
 1271 IF n% < 200 THEN PRINT " ?" ELSE PRINT
 1280 PRINT:PRINT"435 Mhz BEACON"
 1290 PROCget_tm(46)
 1300 PRINT"Current";TAB(p%),0.44*n%
 1310 PROCget_tm(45)
 1320 IF n% > 175 THEN PRINT"Power";TAB(p%),(2.5*n%-200) ELSE PRINT"Power";TAB(p%),0
 1321 PRINT:PRINT"2.4 Ghz BEACON"
 1322 PROCget_tm(56)
 1323 PRINT"Current";TAB(p%),0.45*n%
 1324 PROCget_tm(55)
 1325 PRINT"Power";TAB(p%),(n%+50)*(n%+50)/2400
 1330 PRINT:PRINT "More Channels? Y/N ";
 1331 reply$ = GET$:PRINT
 1334 IF FNno THEN @%=10:ENDPROC
      
 1340 PRINT:PRINT:PRINT
 1350 PRINT"NAVIGATION MAGNETOMETER"
 1360 PRINT
 1370 PROCget_tm(1)
 1380 mx=0.152*n%-69.8
 1381 PRINT"X-axis";TAB(p%),mx
 1390 PROCget_tm(3)
 1400 my=0.155*n%-71.0
 1401 PRINT"Y-axis";TAB(p%),my
 1410 PROCget_tm(2)
 1420 mz=0.146*n%-65.3
 1421 PRINT"Z-axis";TAB(p%),mz
 1422 PRINT"Total field",TAB(p%),SQR(mx*mx+my*my+mz*mz)
 1423 PRINT"Angle to Z axis";TAB(p%),ABS(DEG(ATN((SQR(mx*mx+my*my))/mz)))
 1430 PRINT:PRINT
 1440 @% = 10 :REM Restore default number display
 1450 PROCbar_wait
 1460 ENDPROC
 1470 REM -------------
 1480 DEF PROCget_uosat2
 1490 REM Scan file looking for sequence of characters "UOSAT-2".  When found sets uosat% TRUE.  Terminates just before end of file
 1500 uosat2%=FALSE
 1510 REPEAT
 1520   IF NOT (BGET#f1=&55) THEN 1600: REM U
 1530   IF NOT (BGET#f1=&4F) THEN 1600: REM O
 1540   IF NOT (BGET#f1=&53) THEN 1600: REM S
 1550   IF NOT (BGET#f1=&41) THEN 1600: REM A
 1560   IF NOT (BGET#f1=&54) THEN 1600: REM T
 1570   IF NOT (BGET#f1=&2D) THEN 1600: REM -
 1580   IF NOT (BGET#f1)=&32) THEN 1600: REM 2
 1590   uosat2%=TRUE
 1600 UNTIL (PTR#f1>(file_length%-10)) OR uosat2%
 1620 ENDPROC
 1630 REM -----------
 1640 DEF PROCget_tm(ch_no%)
 1650 LOCAL i%
 1660 ch_tens%=ch_no% DIV 10
 1670 ch_units%=ch_no% MOD 10
 1680 PTR#f1=file_ptr%
 1690 REPEAT
 1695   PTR#f1 = PTR#f1 - 2 : REM Back track 2, so that we only advance by 1 byte
 1700 UNTIL ((BGET#f1=&D)AND(BGET#f1=&A)AND(BGET#f1=&A)) :REM file now positioned on  CR LF LF before TM block
 1710 PTR#f1=PTR#f1+ch_tens%*62+ch_units%*6
 1720 FOR i%=1 TO 6
 1730   c%(i%)=FNhex(BGET#f1) : REM get all 6 digits of TM, and decode ASCII
 1740 NEXT i%
 1750 REM check channel no
 1760 REM IF NOT ((ch_tens%=c%(1)) AND (ch_units%=c%(2))) THEN PROCnormal_format:PRINT:PRINT "Channel No error.  Expected ";ch_no%;"  Read  ";c%(1)*10+c%(2):PROCrestore_format
 1761 IF NOT ((ch_tens%=c%(1)) AND (ch_units%=c%(2))) THEN PRINT "Channel error ... data out of sync"
 1770 IF analogue%=TRUE THEN n%=c%(3)*100+c%(4)*10+c%(5) ELSE n%=c%(3)*&100+c%(4)*&10+c%(5)
 1780 REM now calculate checksum
 1790 checksum%=c%(1)
 1800 FOR i%= 2 TO 6
 1810   checksum%=checksum% EOR c%(i%)
 1820 NEXT i%
 1830 REM IF NOT (checksum%=0) THEN PROCnormal_format:PRINT:PRINT"Checksum error.  Channel  ";ch_no%:FOR i%=1 TO 6: PRINT; ~c%(i%)" ";:NEXT i%:PRINT: PROCrestore_format
 1831 IF NOT (checksum%=0) THEN PRINT"Checksum error."
 1840 ENDPROC
 1850 REM----------
 1860 DEF FNhex(byte%)
 1870 REM Converts single ASCII chr to HEX. Assumes range &30 to &45
 1880 IF (byte% > &40) AND (byte% < &47) THEN temp%=byte%-&37 ELSE temp%=byte%-&30
 1890 =temp%
 1900 REM---------
 1910 REM Functions for converting telemetry data to real units
 1920 DEF FNtemp(n%)=(480-n%)/5
 1930 DEF FNarraycur(n%)=1.9*(516-n%)
 1940 REM ---------
 1950 DEF PROCnormal_format
 1960 REM Saves the current print format in format%, changes to default 10
 1970 format% = @%
 1980 @% = 10
 1990 ENDPROC
 2000 REM --------
 2010 DEF PROCrestore_format
 2020 REM Restores the format to value previously stored in format%
 2030 @% = format%
 2040 ENDPROC
 2050 REM -------
 2060 DEF PROCstatus_tm
 2070 REM Displays status bits in channels 60 to 67.  The order of display and contents is fixed
 2080 analogue% = FALSE :REM Channel data must be in Hexadecimal
 2090 ch_no%=60
 2100 REPEAT
 2110   PROCget_tm(ch_no%)
 2120   PRINT:PRINT"Channel no =  ";ch_no%;"     Status word =  ";~n%
 2130   PRINT
 2140   idlineno%=5000+(ch_no%-60)*120 :REM **** 5000 refers to first line of DATA titles
 2150   mask%=2048 :REM Start with MS bit
 2160   FOR i%=1 TO 12
 2170     RESTORE idlineno%
 2180     READ chid$,type%
 2190     RESTORE (6000+type%*10) :REM **** 6000 refers to first line of DATA states ***
 2200     READ state0$,state1$
 2210     bit%=n% AND mask% :REM Select the bit we want
 2220     PRINT;(ch_no%-60)*12+i%-1;TAB(4);chid$;TAB(30);
 2230     IF bit%=0 THEN PRINT state0$ ELSE PRINT state1$
 2240     mask%=mask% DIV 2 : REM Ready for next bit
 2250     idlineno%=idlineno%+10
 2260   NEXT i%
 2270   ch_no% =ch_no%+1
 2280   PRINT
 2290   PRINT "More status points? <Y/N>  "
 2300   reply$ = GET$
 2310 UNTIL (FNno) OR (ch_no%>67)
 2320 ENDPROC
 2330 REM --------
 2340 DEF FNyes
 2350 REM Input reply$
 2360 REM Returns -1 (TRUE) if reply is Y, otherwise 0 (FALSE)
 2370 IF ((reply$ = "Y") OR (reply$ = "y")) THEN = TRUE ELSE = FALSE
 2380 REM ------
 2390 DEF FNno
 2400 REM Input reply$
 2410 REM Returns -1 (TRUE) if reply is N, otherwise 0 (FALSE)
 2420 IF ((reply$ = "N") OR (reply$ = "n")) THEN = TRUE ELSE = FALSE
 2430 REM -------
 2440 DEF PROCdisplay_time
 2470 REPEAT  : REM Skip the spaces after UOSAT-2
 2480 UNTIL CHR$(BGET#f1) <> " "
 2490 PTR#f1 = PTR#f1 - 1 :REM Back one so that we can print the first character of date
 2500 PRINT
 2510 PRINT "Date  ";
 2520 PRINT CHR$(BGET# f1);CHR$(BGET# f1); :REM year
 2530 PRINT "-";CHR$(BGET# f1);CHR$(BGET# f1);: REM month
 2540 PRINT "-";CHR$(BGET# f1);CHR$(BGET# f1);: REM day
 2550 PTR#f1 = PTR#f1+1 :REM Skip day of week number
 2560 PRINT "   Time  ";CHR$(BGET#f1);CHR$(BGET# f1);":";CHR$(BGET#f1);CHR$(BGET# f1);":";CHR$(BGET# f1);CHR$(BGET#f1): REM time
 2570 ENDPROC
 3000 REM ------
 3010 DEF PROCreset_file
 3020 REM Allows user to change file pointer
 3030 PRINT:PRINT "Enter new file pointer in range 0 to ";file_length%;
 3040 INPUT"  ", ptr%
 3050 PTR#f1 = ptr%  :PRINT
 3060 ENDPROC
 3080 REM________
 3090 DEF PROCbar_wait
 3100 PRINT
 3110 PRINT "Press space bar to contiune"
 3120 IF GET
 3130 ENDPROC
 3140 REM---------
 3150 REM Deal with End of file and errors
 3160 IF (ERR<>254) PROCnormal_format:PRINT:REPORT:PRINT " at line ";ERL: CLOSE# 0: END : REM Error terminate program
 3170 REM Otherwise its end of file
 3180 PRINT:PRINT"End of data reached ... Enter new file pointer in range 0 to ";file_length%;" otherwise press return to exit "
 3190 INPUT reply$
 3200 IF reply$ = "" THEN CLOSE# 0: PROCnormal_format:BYE
 3210 PTR#f1  = VAL(reply$)
 3230 PRINT
 3240 RETURN
 4990 REM -------
 5000 DATA 145 MHz beacon,0
 5010 DATA 435 MHz beacon,0
 5020 DATA 2401 MHz beacon,0
 5030 DATA TM ch mode sel,2
 5040 DATA TM ch dwell addr load,0
 5050 DATA TM ch dwell addr source,3
 5060 DATA Pri computer power,0
 5070 DATAPri computer err bit 1,1
 5080 DATAPri computer err bit 2,1
 5090 DATAPri computer boot,4
 5100 DATAPri computer err bit 3,1
 5110 DATAPri computer boot,5
 5120 DATA Boom pyros,6
 5130 DATA Boom pyros,7
 5140 DATA Boom deployment,6
 5150 DATA Boom deployment,8
 5160 DATA Boom deployment,9
 5170 DATA Magnetorquers,6
 5180 DATA Magnetorquer -X,20
 5190 DATA Magnetorquer -Y,20
 5200 DATA Magnetorquer -Z,20
 5210 DATA Magnetorquer,10
 5220 DATA 435 MHz PSK mode,11
 5230 DATA 2.4 GHz PSK mode,11
 5240 DATA Magnetorquers,12
 5250 DATA Digitalker,0
 5260 DATA Camera,0
 5270 DATA Camera int time bit 0,1
 5280 DATA Camera int time bit 1,1
 5290 DATA Camera gain bit 0,1
 5300 DATA Camera gain bit 1,1
 5310 DATA DSR,0
 5320 DATA DSR mode,19
 5330 DATA DSR mode,14
 5340 DATA Rad det A,0
 5350 DATA Rad det B,0
 5360 DATA Rad det C,0
 5370 DATA El spectrometer,0
 5380 DATA DCE power,0
 5390 DATA DCE status,21
 5400 DATA DCE prom,5
 5410 DATA DCE clocl,15
 5420 DATA Nav mag,0
 5430 DATA Space dust,0
 5440 DATA Status cal,0
 5450 DATA BCR status,5
 5460 DATA 435 MHz mod,16
 5470 DATA 2.4 GHz mod,16
 5480 DATA Eng data bit 1,1
 5490 DATA Eng data     2,1
 5500 DATA Eng data     3,1
 5510 DATA Eng data     4,1
 5520 DATA Eng data     5,1
 5530 DATA Cmd watchdog,17
 5540 DATA Cmd watchdog reset,14
 5550 DATA "145 Mhz data A",1
 5560 DATA "             B",1
 5570 DATA "             C",1
 5580 DATA "             D",1
 5590 DATA "             E",1
 5600 DATA "145 MHz data F",1
 5610 DATA "145 MHz rate A",1
 5620 DATA "             B",1
 5630 DATA "435 MHz rate A",1
 5640 DATA "             B",1
 5650 DATA "             C",1
 5660 DATA P/W counter cntrl,18
 5670 DATA Beacon lockout latch,11
 5680 DATA "Eng data bit 6",1
 5690 DATA "             7",1
 5700 DATA "             8",1
 5710 DATA "             9",1
 5720 DATA "P/W plate ctrl bit 2",1
 5730 DATA "                   1",1
 5740 DATA "                   0",1
 5750 DATA "Space dust bit     7",1
 5760 DATA "                   6",1
 5770 DATA "                   5",1
 5780 DATA "                   4",1
 5790 DATA "                   3",1
 5800 DATA "                   2",1
 5810 DATA "                   1",1
 5820 DATA "                   0",1
 5830 DATA DSR write complete,1
 5840 DATA 1802 CWO output,0
 5850 DATA "1802 TM port bit   10",1
 5860 DATA "                   9",1
 5870 DATA "                   8",1
 5880 DATA "                   7",1
 5890 DATA "                   6",1
 5900 DATA "                   5",1
 5910 DATA "                   4",1
 5920 DATA "                   3",1
 5930 DATA "                   2",1
 5940 DATA "                   1",1
 5950 DATA "                   0",1
 5980 REM Data states
 6000 DATA OFF,ON
 6010 DATA 0,1
 6020 DATA RUN,DWELL
 6030 DATA GROUND,COMPUTER
 6040 DATA PROM,UART
 6050 DATA A,B
 6060 DATA SAFE,ARM
 6070 DATA FIRE,HOLD
 6080 DATA DEPLOY,HOLD
 6090 DATA EXTEND,RETRACT
 6100 DATA REVERSE,FORWARD
 6110 DATA NRZI,NRZIC
 6120 DATA HI PWR,LO PWR
 6130 DATA READ,WRITE
 6140 DATA RUN,RESET
 6150 DATA 0.9 MHz,1.8 MHz
 6160 DATA AFSK,PSK
 6170 DATA DISABLE,ENABLE
 6180 DATA COUNT,RESET
 6190 DATA READ,WRITE
 6200 DATA ON,OFF
 6210 DATA RESET,RUN
 6211 REM ---- END OF CODE -----
      
